package cn.com.qmth.examcloud.service.core.api;

import cn.com.qmth.examcloud.service.core.dao.LearnCenterRepo;
import cn.com.qmth.examcloud.service.core.entity.LearnCenter;
import cn.com.qmth.examcloud.service.core.service.LearnCenterService;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.PageRequest;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

/**
 * 学校中心服务API
 * Created by songyue on 17/1/14.
 */
@RestController
@RequestMapping("${app.api.root}/learn_enter")
public class LearnCenterApi {

    @Autowired
    LearnCenterRepo learnCenterRepo;

    @Autowired
    LearnCenterService learnCenterService;

    @ApiOperation(value="查询所有学习中心",notes="分页")
    @GetMapping("/all/{curPage}/{pageSize}")
    public ResponseEntity getAllLearnCenter(@ModelAttribute LearnCenter learnCenterCriteria, @PathVariable Integer curPage, @PathVariable Integer pageSize){
        return learnCenterService.getAllLearnCenter(learnCenterCriteria,new PageRequest(curPage - 1,pageSize));
    }

    @ApiOperation(value="查询所有学习中心",notes="不分页")
    @GetMapping("/all")
    public ResponseEntity getAllLearnCenter(@ModelAttribute LearnCenter learnCenterCriteria){
        return learnCenterService.getAllLearnCenter(learnCenterCriteria);
    }

    @ApiOperation(value="按ID查询学习中心",notes="ID查询")
    @GetMapping("/{id}")
    public ResponseEntity<LearnCenter> getLearnCenterById(@PathVariable Long id){
        return learnCenterService.getLearnCenterById(id);
    }

    @ApiOperation(value="新增学习中心",notes="新增")
    @PostMapping
    public ResponseEntity addLearnCenter(@ModelAttribute LearnCenter learnCenter){
        return learnCenterService.saveLearnCenter(learnCenter);
    }

    @ApiOperation(value="更新学习中心",notes="更新")
    @PutMapping
    public ResponseEntity updateLearnCenter(@ModelAttribute LearnCenter learnCenter){
        return learnCenterService.saveLearnCenter(learnCenter);
    }

    @ApiOperation(value="按ID删除学习中心",notes="删除")
    @DeleteMapping("/{id}")
    public ResponseEntity deleteLearnCenter(@PathVariable Long id){
        return learnCenterService.deleteLearnCenter(id);
    }
}
